#! /usr/bin/env python

import cgi
import urlparse
from fred_whois import whois
from urllib import quote
from beaker.middleware import SessionMiddleware

class Connection:
   def __init__(self, environ):
      self.remote_ip=environ['REMOTE_ADDR']

class Req:
   def __init__(self, environ):
      self.connection=Connection(environ)

def get_mod_python_req(environ):
   return Req(environ)

def get_url(environ):
   url = environ['wsgi.url_scheme']+'://'
   if environ.get('HTTP_HOST'):
      url += environ['HTTP_HOST']
   else:
      url += environ['SERVER_NAME']

      if environ['wsgi.url_scheme'] == 'https':
         if environ['SERVER_PORT'] != '443':
            url += ':' + environ['SERVER_PORT']
      else:
         if environ['SERVER_PORT'] != '80':
            url += ':' + environ['SERVER_PORT']
   url += quote(environ.get('SCRIPT_NAME', ''))
   url += quote(environ.get('PATH_INFO', ''))
   if environ.get('QUERY_STRING'):
      url += '?' + environ['QUERY_STRING']
   return url

def get_whois_req(environ):
   parsed_uri = urlparse.urlsplit(get_url(environ))
   return (
         environ.get('SERVER_NAME', ''),
         "python",
         get_url(environ),
         [
            parsed_uri.scheme,
            parsed_uri.netloc,
            parsed_uri.username,
            parsed_uri.password,
            parsed_uri.hostname,
            parsed_uri.port,
            parsed_uri.path,
            parsed_uri.query,
            parsed_uri.fragment,
         ],
         get_url(environ),
   )

def application(environ, start_response):

   try:
      session = environ['beaker.session']
      r = get_whois_req(environ)
      w = whois.Whois(r, session)

      # request goes to PDF request, we need Whois instance
      if r[3][6] == whois.conf.get('pdf', 'location'):
         sid = session.get('pdf_id', None)
         if not sid:
            raise "No pdf_id in session"
         pdf = None
         try:
            if w.lang == 'cz': 
               # 'cz' is used in whole enum website, 'cs' in corba
               pdflang = 'cs'
            else:
               pdflang = 'en'
               pdf = w.admin.getPublicRequestPDF(sid, pdflang)
         except Exception, e:
            raise e
         start_response(
            "200 OK",
            [('Content-Type', 'application/pdf'), 
             ('Content-Length', str(len(pdf))),
             ('Content-Disposition', 
              'attachment; filename=CZ-NIC_PasswordRequest.pdf')]
         )
         return [pdf]

      form = cgi.FieldStorage(fp=environ['wsgi.input'],environ=environ)
      req = get_mod_python_req(environ)
      response_body, redirect_url = w.render(
         whois.get_form_data(req, form), 
         links={'registrars_list': '/whois/registrars'}
      )
      if redirect_url:
         start_response(
            '301 Redirect', 
            [('Location',  redirect_url),]
         )
         return []
      else:
         start_response(
            '200 OK', 
            [('Content-Type', 'text/html'),
             ('Content-Length', str(len(response_body)))]
         )
         return [response_body]
   except:
      raise

session_opts = {
    'session.auto': True,
    'session.type': 'cookie',
    'session.validate_key': 'asdasdasd',
}
application = SessionMiddleware(application, session_opts)
